package game;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.DefaultComboBoxModel;

import units.BlueCommando;
import units.BlueGrenadier;
import units.BlueSniper;
import units.BlueSoldier;
import units.RedCommando;
import units.RedGrenadier;
import units.RedSniper;
import units.RedSoldier;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class ChoseUnitWindow extends JFrame {

	private JPanel contentPane;


	public ChoseUnitWindow(final GameMap map, final MapEditor ed) {
		
		/**
		 * These values are used to fill the x/y position combo boxes so that they have the right values
		 * We create an integer the same size as the height/width then create a string array of the correct length
		 * We use a for loop to fill each array
		 */
		
		int testvarx = map.getWidth();
		int testvary = map.getHeight();
				
		String[] splitsX = new String[testvarx];
		String[] splitsY = new String[testvary];
		
		for (int i = 0; i < testvarx; i++){
			splitsX[i] = Integer.toString(i);
		}
		
		for (int j = 0; j < testvary; j++){
			splitsY[j] = Integer.toString(j);
		}
		
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setBounds(100, 100, 501, 193);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		final JComboBox cB_SelectTeam = new JComboBox();
		cB_SelectTeam.setModel(new DefaultComboBoxModel(new String[] {"Select Team", "Red", "Blue"}));
		cB_SelectTeam.setBounds(5, 60, 119, 20);
		contentPane.add(cB_SelectTeam);
		
		final JComboBox cB_UnitType = new JComboBox();
		cB_UnitType.setModel(new DefaultComboBoxModel(new String[] {"Select Type", "Soldier", "Sniper", "Commando", "Grenadier"}));
		cB_UnitType.setBounds(134, 60, 100, 20);
		contentPane.add(cB_UnitType);
		
		final JComboBox cB_AddX = new JComboBox(splitsX);
		cB_AddX.setBounds(244, 60, 40, 20);
		contentPane.add(cB_AddX);
		
		final JComboBox cB_AddY = new JComboBox(splitsY);
		cB_AddY.setBounds(294, 60, 40, 20);
		contentPane.add(cB_AddY);
		
		final JComboBox cB_RemX = new JComboBox(splitsX);
		cB_RemX.setBounds(5, 119, 40, 20);
		contentPane.add(cB_RemX);
		
		final JComboBox cB_RemY = new JComboBox(splitsY);
		cB_RemY.setBounds(55, 119, 40, 20);
		contentPane.add(cB_RemY);
		
		JButton btnAddUnit = new JButton("Add Unit");
		
		btnAddUnit.setBounds(340, 59, 89, 23);
		btnAddUnit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.out.println("Adding Unit");
				
				/**
				 * here we translate the values from the combo boxes into things we can use
				 * to position the units. 
				 * The type number defines what unit class to spawn
				 * int x and int y are pulled from combo boxes and tell us where to put the unit
				 */
				
				int team = cB_SelectTeam.getSelectedIndex();
				int type = cB_UnitType.getSelectedIndex();
				int x = cB_AddX.getSelectedIndex();
				int y = cB_AddY.getSelectedIndex();				
				if (team == 1){					
					if (type == 1){
						RedSoldier newUnit = new RedSoldier();
						map.setUnitInCell(x, y, newUnit);
					}
					
					if (type == 2){
						RedSniper newUnit = new RedSniper();
						map.setUnitInCell(x, y, newUnit);
					}
					
					if (type == 3){
						RedCommando newUnit = new RedCommando();
						map.setUnitInCell(x, y, newUnit);
					}							
					
					if (type == 4){
						RedGrenadier newUnit = new RedGrenadier();
						map.setUnitInCell(x, y, newUnit);
					}
				}
				else if (team == 2){
					
					if (type == 1){
						BlueSoldier newUnit = new BlueSoldier();
						map.setUnitInCell(x, y, newUnit);
					}
					
					if (type == 2){
						BlueSniper newUnit = new BlueSniper();
						map.setUnitInCell(x, y, newUnit);
					}
					
					if (type == 3){
						BlueCommando newUnit = new BlueCommando();
						map.setUnitInCell(x, y, newUnit);
					}	
					
					if (type == 4){
						BlueGrenadier newUnit = new BlueGrenadier();
						map.setUnitInCell(x, y, newUnit);
					}
				}
				ed.repaint(0);
			}
		});
		contentPane.add(btnAddUnit);
		
		/**
		 * This does the same as the above, but uses only two combo boxes to choose where to remove a unit from
		 */
		
		JButton btnDeleteUnit = new JButton("Delete Unit");
		btnDeleteUnit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int x = cB_RemX.getSelectedIndex();
				int y = cB_RemY.getSelectedIndex();
				if (map.getUnitInNode(x,y) != null){
					map.clearUnitInCell(x, y);
					ed.repaint(0);
				}
			}
		});
		btnDeleteUnit.setBounds(104, 118, 89, 23);
		contentPane.add(btnDeleteUnit);
		
		JLabel lblThisWindowAllows = new JLabel("This window allows you to add or remove units.");
		lblThisWindowAllows.setBounds(5, 5, 424, 16);
		lblThisWindowAllows.setFont(new Font("Tahoma", Font.PLAIN, 13));
		contentPane.add(lblThisWindowAllows);
		
		JLabel lblUnitAddition = new JLabel("Unit Addition");
		lblUnitAddition.setBounds(5, 35, 113, 14);
		contentPane.add(lblUnitAddition);
		
		JLabel lblUnitRemoval = new JLabel("Unit Removal");
		lblUnitRemoval.setBounds(5, 94, 73, 14);
		contentPane.add(lblUnitRemoval);
	}
}
