package game;

import game.GameInterface.MapSelect;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

public class EndGameWindow extends JFrame {

	private JPanel contentPane;


	/**
	 * This class creates a window when the game has finished. 
	 * The arguments are used to calculate how many units each player killed during the match
	 * and to display the total number of turns played
	 */
	

	public EndGameWindow(int totalTurns, int redRemaining, int blueRemaining, int initialRed, int initialBlue) {
		setVisible(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);

		JLabel lblNewLabel = new JLabel("Game Over");
		lblNewLabel.setBounds(5, 5, 424, 37);
		lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 30));
		lblNewLabel.setHorizontalAlignment(SwingConstants.CENTER);
		contentPane.add(lblNewLabel);

		if (redRemaining > blueRemaining){

			JLabel lblWasTheVictor = new JLabel("Red player was the victor!");
			Game.globalredwins += 1;
			lblWasTheVictor.setBounds(5, 42, 424, 42);
			lblWasTheVictor.setHorizontalAlignment(SwingConstants.CENTER);
			lblWasTheVictor.setFont(new Font("Tahoma", Font.PLAIN, 20));
			contentPane.add(lblWasTheVictor);
		}

		else if (blueRemaining > redRemaining){
			JLabel lblWasTheVictor = new JLabel("Blue player was the victor!");
			Game.globalbluewins +=1;
			lblWasTheVictor.setBounds(5, 42, 424, 42);
			lblWasTheVictor.setHorizontalAlignment(SwingConstants.CENTER);
			lblWasTheVictor.setFont(new Font("Tahoma", Font.PLAIN, 20));
			contentPane.add(lblWasTheVictor);
		}
		
		else {
			JLabel lblWasTheVictor = new JLabel("The game ended in a draw");
			lblWasTheVictor.setBounds(5, 42, 424, 42);
			lblWasTheVictor.setHorizontalAlignment(SwingConstants.CENTER);
			lblWasTheVictor.setFont(new Font("Tahoma", Font.PLAIN, 20));
			contentPane.add(lblWasTheVictor);
		}

		JLabel lblNewLabel_1 = new JLabel("Game Statistics");
		lblNewLabel_1.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblNewLabel_1.setHorizontalAlignment(SwingConstants.CENTER);
		lblNewLabel_1.setBounds(10, 93, 414, 14);
		contentPane.add(lblNewLabel_1);

		JLabel lblStat = new JLabel("Total turns completed: " + totalTurns);
		Game.globalturncount += totalTurns;
		lblStat.setHorizontalAlignment(SwingConstants.CENTER);
		lblStat.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblStat.setBounds(5, 113, 424, 14);
		contentPane.add(lblStat);

		JLabel lblStat_1 = new JLabel("Red killed: " + (initialBlue - blueRemaining) + " units");
		Game.globalredkills += (initialRed-redRemaining);
		lblStat_1.setHorizontalAlignment(SwingConstants.CENTER);
		lblStat_1.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblStat_1.setBounds(5, 129, 424, 14);
		contentPane.add(lblStat_1);

		JLabel lblStat_2 = new JLabel("Blue killed: " + (initialRed - redRemaining) + " units");
		Game.globalbluekills += (initialBlue - blueRemaining);
		lblStat_2.setHorizontalAlignment(SwingConstants.CENTER);
		lblStat_2.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblStat_2.setBounds(5, 145, 424, 14);
		contentPane.add(lblStat_2);
		
		JButton btnDone = new JButton("Done");
		btnDone.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				instanceRetriever().dispose();
				
			}
		});
		btnDone.setBounds(175, 204, 89, 23);
		contentPane.add(btnDone);

	}
	
	public EndGameWindow instanceRetriever(){
		return this;
	}
}
