package game;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.Font;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.Canvas;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.SwingConstants;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.RowSpec;
import net.miginfocom.swing.MigLayout;
import javax.swing.JLayeredPane;

public class GameInterface extends JFrame {

	static boolean mapSaved = false;
	static int choosewidth;
	static int chooseheight;
	static int AIChoice;
	private JPanel contentPane;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					GameInterface frame = new GameInterface();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}


	public GameInterface() {

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 502, 520);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(new BorderLayout(0, 0));

		JLayeredPane layeredPane = new JLayeredPane();
		contentPane.add(layeredPane, BorderLayout.CENTER);
		layeredPane.setLayout(null);

		JLabel lblNewLabel = new JLabel("New label");
		lblNewLabel.setIcon(new ImageIcon("res\\interface\\splash.png"));
		lblNewLabel.setBounds(0, 0, 476, 472);
		layeredPane.add(lblNewLabel);

		/**
		 * This launches a single player game
		 */
			
		JButton btnSP = new JButton("New Single Player Match (Versus AI)");
		btnSP.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				MapSelect optionbox = new MapSelect();
			}
		});
		layeredPane.setLayer(btnSP, 1);
		btnSP.setBounds(112, 310, 256, 30);
		layeredPane.add(btnSP);

		/**
		 * This launches a multiplayer game
		 */
		JButton btnMP = new JButton("New Multi Player Match (Versus Friend)");
		btnMP.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				
				MapSelectSP optionbox = new MapSelectSP();
			}
		});
		layeredPane.setLayer(btnMP, 1);
		btnMP.setBounds(112, 340, 256, 30);
		layeredPane.add(btnMP);

		/**
		 * This launches the map editor
		 */
		
		JButton btnMapEdit = new JButton("Map Editor");
		btnMapEdit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				MapParams test1 = new MapParams();
			}
		});
		layeredPane.setLayer(btnMapEdit, 1);
		btnMapEdit.setBounds(112, 370, 256, 30);
		layeredPane.add(btnMapEdit);

		/**
		 * This shows the game statistics window 
		 */
		
		JButton btnStats = new JButton("Session Statistics");
		btnStats.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				StatWindow stats = new StatWindow();
			}
		});
		layeredPane.setLayer(btnStats, 1);
		btnStats.setBounds(112, 400, 256, 30);
		layeredPane.add(btnStats);

		/**
		 * This closes the window
		 */
		JButton btnX = new JButton("");
		btnX.setSelectedIcon(new ImageIcon(GameInterface.class.getResource("/javax/swing/plaf/metal/icons/ocean/close-pressed.gif")));
		btnX.setIcon(new ImageIcon(GameInterface.class.getResource("/javax/swing/plaf/metal/icons/ocean/close.gif")));
		btnX.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		layeredPane.setLayer(btnX, 1);
		btnX.setBounds(448, 0, 28, 23);
		layeredPane.add(btnX);
	}

	/**
	 * This window is used to define the size of the custom map we create
	 */
	
	public class MapParams extends JFrame {

		private JPanel contentPane;

		public MapParams() {

			int testvarx = 15;
			int testvary = 15;

			String[] splitsX = new String[testvarx];
			String[] splitsY = new String[testvary];
			
			/**
			 * We fill the arrays by iterating through them however unlike in chooseunitwindow,
			 * we add ten to the index so that we start at 10 and finish at 25, since those are
			 * the lower and upper bounds for map sizes
			 */

			for (int i = 0; i < testvarx; i++){
				splitsX[i] = Integer.toString(i+10);
			}

			for (int j = 0; j < testvarx; j++){
				splitsY[j] = Integer.toString(j+10);
			}


			setVisible(true);
			setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			setBounds(100, 100, 353, 150);
			contentPane = new JPanel();
			contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
			setContentPane(contentPane);
			contentPane.setLayout(new GridLayout(3, 2, 0, 0));

			JLabel lblPleaseChooseMap = new JLabel("Please choose map size:");
			contentPane.add(lblPleaseChooseMap);

			JLabel lblNewLabel = new JLabel("");
			contentPane.add(lblNewLabel);

			final JComboBox cB_Width = new JComboBox(splitsX);
			contentPane.add(cB_Width);

			final JComboBox cB_Height = new JComboBox(splitsY);
			contentPane.add(cB_Height);

			JButton btnGo = new JButton("Start!");
			btnGo.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					GameMap.mapselection = 0;
					
					/**
					 * This launches the map editor class
					 * We pull the values from the height/width combo boxes uses parseint rather than
					 * getselectedindex as we need the value rather than the index
					 */
					
					choosewidth = Integer.parseInt((String)cB_Width.getSelectedItem());
					chooseheight = Integer.parseInt((String)cB_Height.getSelectedItem());
					MapEditor medit = new MapEditor();
					setVisible(false);									
				}
			});

			contentPane.add(btnGo);
		}
	}

	/**
	 * This class is used to select the map we will play on in a multiplayer game
	 * There are combo boxes to select the AI opponent, the turn limit, the map to play on
	 * (either a saved map or one that comes with the game) and a pair of buttons to launch
	 *
	 */

	public class MapSelect extends JFrame {

		private JPanel contentPane;

		public MapSelect() {
			setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			setBounds(100, 100, 297, 229);
			contentPane = new JPanel();
			contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
			contentPane.setLayout(new GridLayout(0, 2, 0, 0));
			setContentPane(contentPane);
			setVisible(true);

			JLabel lblPleaseChooseA = new JLabel("Please choose a map:");
			contentPane.add(lblPleaseChooseA);

			JLabel lblNewLabel = new JLabel("");
			contentPane.add(lblNewLabel);
			
			final JComboBox cB_AISelect = new JComboBox();
			cB_AISelect.setModel(new DefaultComboBoxModel(new String[] {"Choose AI...", "Easy (Standard)", "Easy (Suicidal)", "Easy (Cautious)", "Medium (Standard)", "Medium (Offensive)", "Medium (Defensive)", "Hard (Standard)", "Hard (Aggressive)" ,"Hard (Patient)", "Standard (Alternative)"}));
			cB_AISelect.setBackground(new Color(255, 255, 255));
			contentPane.add(cB_AISelect);
			
			final JComboBox cB_tLimit = new JComboBox();
			cB_tLimit.setModel(new DefaultComboBoxModel(new String[] {"No Turn Limit", "10 Turns", "20 Turns", "30 Turns", "40 Turns"}));
			cB_tLimit.setBackground(new Color(255, 255, 255));
			contentPane.add(cB_tLimit);

			final JComboBox comboBox = new JComboBox();
			comboBox.setModel(new DefaultComboBoxModel(new String[] {"Editor Map", "Boxes", "Open Field", "FaceOff", "Fortress", "Lanes", "Bridge", "Forest", "Concentric"}));
			comboBox.setBackground(new Color(255, 255, 255));
			contentPane.add(comboBox);

			final JComboBox comboBox_1 = new JComboBox();
			comboBox_1.setModel(new DefaultComboBoxModel(new String[] {"Slot 1", "Slot 2", "Slot 3", "Slot 4", "Slot 5"}));
			comboBox_1.setBackground(new Color(255, 255, 255));
			contentPane.add(comboBox_1);
			
			JButton btnStart = new JButton("Start Game");
			contentPane.add(btnStart);
			btnStart.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int contents = comboBox.getSelectedIndex();

					GameMap.mapselection = contents;
					System.out.println(GameMap.mapselection);
					
					AIChoice = cB_AISelect.getSelectedIndex();
					
					int turnIndex = cB_tLimit.getSelectedIndex();
					if (turnIndex == 0){Game.maxTurns = -1;}
					if (turnIndex == 1){Game.maxTurns = 10;}
					if (turnIndex == 2){Game.maxTurns = 20;}
					if (turnIndex == 3){Game.maxTurns = 30;}
					if (turnIndex == 4){Game.maxTurns = 40;}

					if(mapSaved == false && contents == 0){
						System.out.println("Can't do that, no map saved");
					}

					if(mapSaved == true && contents == 0){
						Game test0 = new Game(true);
						setVisible(false);
					}

					else if (contents != 0){
						Game test0 = new Game(false);
						setVisible(false);}

				}
			});	
			
		
			JButton btnLoad = new JButton("Load File");
			btnLoad.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					MapSerializer serial = new MapSerializer();
					int loadslot = comboBox_1.getSelectedIndex();
					/**
					 * Load selected map into savedMap so that it can be cloned
					 */
					MapEditor.savedMap = serial.LoadMap(loadslot);
					mapSaved = true;
					

					AIChoice = cB_AISelect.getSelectedIndex();
					
					int turnIndex = cB_tLimit.getSelectedIndex();
					if (turnIndex == 0){Game.maxTurns = -1;}
					if (turnIndex == 1){Game.maxTurns = 10;}
					if (turnIndex == 2){Game.maxTurns = 20;}
					if (turnIndex == 3){Game.maxTurns = 30;}
					if (turnIndex == 4){Game.maxTurns = 40;}
					
					/**
					 * Argument true so we use the constructor that clones an existing map
					 */
					
					Game test0 = new Game(true);
				}
			});
			contentPane.add(btnLoad);		
		}
	}
	
	public class StatWindow extends JFrame {

		private JPanel contentPane;

		public StatWindow() {
			setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			setBounds(100, 100, 233, 256);
			contentPane = new JPanel();
			contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
			setContentPane(contentPane);
			contentPane.setLayout(new GridLayout(0, 1, 0, 0));
			setVisible(true);
			
			JLabel lblStatsThisSession = new JLabel("Stats this session: ");
			lblStatsThisSession.setFont(new Font("Tahoma", Font.PLAIN, 19));
			lblStatsThisSession.setHorizontalAlignment(SwingConstants.CENTER);
			contentPane.add(lblStatsThisSession);
			
			JLabel lblNewLabel = new JLabel("Total Turns: " + Game.globalturncount);
			lblNewLabel.setHorizontalAlignment(SwingConstants.CENTER);
			contentPane.add(lblNewLabel);
			
			JLabel lblNewLabel_1 = new JLabel("Red has killed " + Game.globalredkills + " units");
			lblNewLabel_1.setHorizontalAlignment(SwingConstants.CENTER);
			contentPane.add(lblNewLabel_1);
			
			JLabel lblNewLabel_2 = new JLabel("Blue has killed " + Game.globalbluekills + " units");
			lblNewLabel_2.setHorizontalAlignment(SwingConstants.CENTER);
			contentPane.add(lblNewLabel_2);
			
			JLabel lblNewLabel_3 = new JLabel("Red has won " + Game.globalredwins + " games");
			lblNewLabel_3.setHorizontalAlignment(SwingConstants.CENTER);
			contentPane.add(lblNewLabel_3);
			
			JLabel lblNewLabel_4 = new JLabel("Blue has won " + Game.globalbluewins + " games");
			lblNewLabel_4.setHorizontalAlignment(SwingConstants.CENTER);
			contentPane.add(lblNewLabel_4);
		}

	}
	
	/**
	 * This is the same as the mapselect class, except that it doesn't specify an AI
	 * opponent since we will be playing against a human player instead
	 */
	
	public class MapSelectSP extends JFrame {

		private JPanel contentPane;

		public MapSelectSP() {
			setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			setBounds(100, 100, 297, 229);
			contentPane = new JPanel();
			contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
			contentPane.setLayout(new GridLayout(0, 2, 0, 0));
			setContentPane(contentPane);
			setVisible(true);

			JLabel lblPleaseChooseA = new JLabel("Please choose a map:");
			contentPane.add(lblPleaseChooseA);

			JLabel lblNewLabel = new JLabel("");
			contentPane.add(lblNewLabel);
			
			final JComboBox cB_tLimit = new JComboBox();
			cB_tLimit.setModel(new DefaultComboBoxModel(new String[] {"No Turn Limit", "10 Turns", "20 Turns", "30 Turns", "40 Turns"}));
			cB_tLimit.setBackground(new Color(255, 255, 255));
			contentPane.add(cB_tLimit);

			final JComboBox comboBox = new JComboBox();
			comboBox.setModel(new DefaultComboBoxModel(new String[] {"Editor Map", "Boxes", "Open Field", "FaceOff", "Fortress", "Lanes", "Bridge", "Forest", "Concentric"}));
			comboBox.setBackground(new Color(255, 255, 255));
			contentPane.add(comboBox);

			final JComboBox comboBox_1 = new JComboBox();
			comboBox_1.setModel(new DefaultComboBoxModel(new String[] {"Slot 1", "Slot 2", "Slot 3", "Slot 4", "Slot 5"}));
			comboBox_1.setBackground(new Color(255, 255, 255));
			contentPane.add(comboBox_1);
			
			JButton btnStart = new JButton("Start Game");
			contentPane.add(btnStart);
			btnStart.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int contents = comboBox.getSelectedIndex();

					GameMap.mapselection = contents;
					System.out.println(GameMap.mapselection);
					
					AIChoice = -1;
					
					int turnIndex = cB_tLimit.getSelectedIndex();
					if (turnIndex == 0){Game.maxTurns = -1;}
					if (turnIndex == 1){Game.maxTurns = 10;}
					if (turnIndex == 2){Game.maxTurns = 20;}
					if (turnIndex == 3){Game.maxTurns = 30;}
					if (turnIndex == 4){Game.maxTurns = 40;}

					if(mapSaved == false && contents == 0){
						System.out.println("Can't do that, no map saved");
					}

					if(mapSaved == true && contents == 0){
						Game test0 = new Game(true);
						setVisible(false);
					}

					else if (contents != 0){
						Game test0 = new Game(false);
						setVisible(false);}

				}
			});	
			
		
			
			JButton btnLoad = new JButton("Load File");
			btnLoad.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					MapSerializer serial = new MapSerializer();
					int loadslot = comboBox_1.getSelectedIndex();
					/**
					 * Load selected map into savedMap
					 */
					MapEditor.savedMap = serial.LoadMap(loadslot);
					mapSaved = true;
					

					AIChoice = -1;
					
					int turnIndex = cB_tLimit.getSelectedIndex();
					if (turnIndex == 0){Game.maxTurns = -1;}
					if (turnIndex == 1){Game.maxTurns = 10;}
					if (turnIndex == 2){Game.maxTurns = 20;}
					if (turnIndex == 3){Game.maxTurns = 30;}
					if (turnIndex == 4){Game.maxTurns = 40;}
					
					Game test0 = new Game(true);
				}
			});
			contentPane.add(btnLoad);
			
			
		}

	}
}



