package game;

import java.util.*;

/** This class stores map layouts. Tiles are assigned the following values:

GRASS = 0; TREE = 1; WATER = 2; WALL = 3;
SOLDIER_RED = 0; SOLDIER_BLUE = 1;
COMM_RED = 2; COMM_BLUE = 3;
SNIPER_RED = 4; SNIPER_BLUE = 5; */



public class MapLayouts {

	static List<unitInitialiser> initList = new ArrayList<unitInitialiser>();

	public static void createMap(int mapselection, GameMap Map) {
		switch (GameMap.mapselection) {

		case 0:
			Map.MAP_HEIGHT = GameInterface.chooseheight;
			Map.MAP_WIDTH = GameInterface.choosewidth;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			fillArea(0,0,Map.MAP_WIDTH,Map.MAP_HEIGHT,GameMap.GRASS, Map);
			break;

		case 1:

			Map.MAP_WIDTH = 15;
			Map.MAP_HEIGHT = 15;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];

			fillArea(3,3,2,2,GameMap.WALL, Map);
			fillArea(10,3,2,2,GameMap.WALL, Map);
			fillArea(3,10,2,2,GameMap.WALL, Map);
			fillArea(10,10,2,2,GameMap.WALL, Map);


			break;



		case 2:

			Map.MAP_WIDTH = 15;
			Map.MAP_HEIGHT = 15;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];


			fillArea(0,0,15,15,GameMap.GRASS, Map);

			break;

		case 3:

			Map.MAP_WIDTH = 15;
			Map.MAP_HEIGHT = 15;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];

			fillArea(0,0,15,1,GameMap.WATER, Map);
			fillArea(0,1,1,14,GameMap.WATER, Map);
			fillArea(1,14,14,1,GameMap.WATER, Map);
			fillArea(14,1,1,13,GameMap.WATER, Map);

			//Upper cover
			fillArea(3,2,2,2,GameMap.WALL, Map);
			fillArea(6,2,3,2,GameMap.WATER, Map);
			fillArea(10,2,2,2,GameMap.WALL, Map);

			//Lower cover
			fillArea(3,11,2,2,GameMap.WALL, Map);
			fillArea(6,11,3,2,GameMap.WATER, Map);
			fillArea(10,11,2,2,GameMap.WALL, Map);

			//Central obstacles
			fillArea(7,6,1,3,GameMap.WALL, Map);
			fillArea(1,6,2,3,GameMap.WALL, Map);
			fillArea(12,6,2,3,GameMap.WALL, Map);

			break;

		case 4:

			Map.MAP_WIDTH = 20;
			Map.MAP_HEIGHT = 20;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];


			fillArea(0,0,20,1,GameMap.WATER, Map);
			fillArea(0,1,1,19,GameMap.WATER, Map);
			fillArea(1,16,19,4,GameMap.WATER, Map);
			fillArea(19,1,1,18,GameMap.WATER, Map);

			//Fortress Area

			fillArea(2,2,16,1,GameMap.WALL, Map);
			fillArea(2,3,1,3,GameMap.WALL, Map);
			fillArea(17,3,1,3,GameMap.WALL, Map);
			fillArea(2,7,4,1,GameMap.WALL, Map);
			fillArea(14,7,4,1,GameMap.WALL, Map);
			fillArea(5,9,1,3,GameMap.WALL, Map);
			fillArea(14,9,1,3,GameMap.WALL, Map);
			fillArea(7,11,6,1,GameMap.WALL, Map);
			fillArea(9,7,2,3,GameMap.WALL, Map);
			fillArea(7,2,6,3,GameMap.WALL, Map);


			//Lower cover

			fillArea(6,16,8,3,GameMap.GRASS, Map);

			break;

		case 5:

			Map.MAP_WIDTH = 14;
			Map.MAP_HEIGHT = 20;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];

			fillArea(2,2,2,5,GameMap.WALL, Map);
			fillArea(6,2,2,5,GameMap.WALL, Map);
			fillArea(10,2,2,5,GameMap.WALL, Map);

			fillArea(2,13,2,5,GameMap.WALL, Map);
			fillArea(6,13,2,5,GameMap.WALL, Map);
			fillArea(10,13,2,5,GameMap.WALL, Map);
			fillArea(0,9,1,2,GameMap.WALL, Map);
			fillArea(13,9,1,2,GameMap.WALL, Map);


			fillArea(1,8,4,4,GameMap.TREE, Map);
			fillArea(9,8,4,4,GameMap.TREE, Map);
			fillArea(6,9,2,2,GameMap.TREE, Map);

			fillArea(5,9,1,2,GameMap.WALL, Map);
			fillArea(8,9,1,2,GameMap.WALL, Map);

			break;

		case 6:

			Map.MAP_WIDTH = 25;
			Map.MAP_HEIGHT = 15;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];

			fillArea(7,0,11,3,GameMap.WATER, Map);
			fillArea(7,12,11,3,GameMap.WATER, Map);

			fillArea(7,0,1,5,GameMap.WALL, Map);
			fillArea(7,10,1,5,GameMap.WALL, Map);
			fillArea(17,0,1,5,GameMap.WALL, Map);
			fillArea(17,10,1,5,GameMap.WALL, Map);

			Map.tiletypes[12][6] = GameMap.WALL;
			Map.tiletypes[12][7] = GameMap.WALL;
			Map.tiletypes[12][8] = GameMap.WALL;
			Map.tiletypes[11][7] = GameMap.WALL;
			Map.tiletypes[13][7] = GameMap.WALL;

			fillArea(2,2,3,3,GameMap.WALL, Map);
			fillArea(3,9,2,4,GameMap.WALL, Map);

			fillArea(20,10,3,3,GameMap.WALL, Map);
			fillArea(20,2,2,4,GameMap.WALL, Map);

			break;


		case 7:

			Map.MAP_WIDTH = 19;
			Map.MAP_HEIGHT = 19;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];

			fillArea(1,8,4,4,GameMap.TREE, Map);
			fillArea(7,5,4,4,GameMap.TREE, Map);
			fillArea(13,13,4,4,GameMap.TREE, Map);
			fillArea(11,4,4,4,GameMap.TREE, Map);
			fillArea(6,11,3,6,GameMap.TREE, Map);
			fillArea(6,11,3,3,GameMap.TREE, Map);
			fillArea(1,1,12,2,GameMap.TREE, Map);
			fillArea(16,4,2,10,GameMap.TREE, Map);
			
			fillArea(11,9,3,3,GameMap.WATER, Map);
			fillArea(1,4,5,3,GameMap.WATER, Map);
			fillArea(1,13,3,5,GameMap.WATER, Map);
			
			fillArea(10,13,2,3,GameMap.WALL, Map);
			
			fillArea(14,1,3,2,GameMap.WALL, Map);
			


			break;
			
		case 8:

			Map.MAP_WIDTH = 15;
			Map.MAP_HEIGHT = 15;
			Map.tiletypes = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			//GameMap.wallLocations = new int[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalShots = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];
			GameMap.legalMoves = new boolean[Map.MAP_WIDTH][Map.MAP_HEIGHT];

			fillArea(0,0,15,1,GameMap.WATER, Map);
			fillArea(0,1,1,14,GameMap.WATER, Map);
			fillArea(1,14,14,1,GameMap.WATER, Map);
			fillArea(14,1,1,13,GameMap.WATER, Map);
			
			fillArea(3,3,4,1,GameMap.WALL, Map);
			fillArea(8,3,4,1,GameMap.WALL, Map);
			
			fillArea(3,11,4,1,GameMap.WALL, Map);
			fillArea(8,11,4,1,GameMap.WALL, Map);
			
			fillArea(3,3,1,4,GameMap.WALL, Map);
			fillArea(3,8,1,4,GameMap.WALL, Map);
			fillArea(11,3,1,4,GameMap.WALL, Map);
			fillArea(11,8,1,4,GameMap.WALL, Map);
			
			Map.tiletypes[6][6] = GameMap.WALL;
			Map.tiletypes[8][6] = GameMap.WALL;
			Map.tiletypes[8][8] = GameMap.WALL;
			Map.tiletypes[6][8] = GameMap.WALL;
			
			Map.tiletypes[7][1] = GameMap.WALL;
			Map.tiletypes[7][13] = GameMap.WALL;
			Map.tiletypes[1][7] = GameMap.WALL;
			Map.tiletypes[13][7] = GameMap.WALL;
			
			Map.tiletypes[7][7] = GameMap.TREE;
			Map.tiletypes[7][6] = GameMap.TREE;
			Map.tiletypes[7][8] = GameMap.TREE;
			Map.tiletypes[6][7] = GameMap.TREE;
			Map.tiletypes[8][7] = GameMap.TREE;

			break;
		}
		
		
	}




	public static List<unitInitialiser> createUnits(int MapSelection){
		initList = new ArrayList<unitInitialiser>();
		switch (MapSelection) {

		case 1:
			unitInitialiser c1u1 = new unitInitialiser(1,1,1);
			unitInitialiser c1u2 = new unitInitialiser(2,7,1);
			unitInitialiser c1u3 = new unitInitialiser(3,13,1);
			unitInitialiser c1u4 = new unitInitialiser(4,1,13);
			unitInitialiser c1u5 = new unitInitialiser(5,7,13);
			unitInitialiser c1u6 = new unitInitialiser(6,13,13);
			initList.add(c1u1);
			initList.add(c1u2);
			initList.add(c1u3);
			initList.add(c1u4);
			initList.add(c1u5);
			initList.add(c1u6);
			break;

		case 2: 
			unitInitialiser c2u1 = new unitInitialiser(1,1,1);
			unitInitialiser c2u2 = new unitInitialiser(2,7,1);
			unitInitialiser c2u3 = new unitInitialiser(3,13,1);
			unitInitialiser c2u4 = new unitInitialiser(4,1,13);
			unitInitialiser c2u5 = new unitInitialiser(5,7,13);
			unitInitialiser c2u6 = new unitInitialiser(6,13,13);
			initList.add(c2u1);
			initList.add(c2u2);
			initList.add(c2u3);
			initList.add(c2u4);
			initList.add(c2u5);
			initList.add(c2u6);
			break;

		case 3:
			unitInitialiser c3u1 = new unitInitialiser(1,1,1);
			unitInitialiser c3u2 = new unitInitialiser(2,4,1);
			unitInitialiser c3u3 = new unitInitialiser(3,13,1);
			unitInitialiser c3u4 = new unitInitialiser(4,1,13);
			unitInitialiser c3u5 = new unitInitialiser(5,4,13);
			unitInitialiser c3u6 = new unitInitialiser(6,13,13);
			unitInitialiser c3u7 = new unitInitialiser(7,8,1);
			unitInitialiser c3u8 = new unitInitialiser(8,8,13);
			initList.add(c3u1);
			initList.add(c3u2);
			initList.add(c3u3);
			initList.add(c3u4);
			initList.add(c3u5);
			initList.add(c3u6);
			initList.add(c3u7);
			initList.add(c3u8);
			break;

		case 4:

			unitInitialiser c4u1 = new unitInitialiser(1,3,3);
			unitInitialiser c4u2 = new unitInitialiser(1,16,3);
			unitInitialiser c4u3 = new unitInitialiser(2,6,3);
			unitInitialiser c4u4 = new unitInitialiser(2,13,3);
			unitInitialiser c4u5 = new unitInitialiser(7,6,10);
			unitInitialiser c4u6 = new unitInitialiser(7,13,10);
			unitInitialiser c4u7 = new unitInitialiser(3,9,10);
			
			unitInitialiser c4u8 = new unitInitialiser(4,6,17);
			unitInitialiser c4u9 = new unitInitialiser(5,7,17);
			unitInitialiser c4u10 = new unitInitialiser(6,8,17);
			unitInitialiser c4u11 = new unitInitialiser(8,9,17);
			unitInitialiser c4u12 = new unitInitialiser(5,10,17);
			unitInitialiser c4u13 = new unitInitialiser(6,11,17);
			unitInitialiser c4u14 = new unitInitialiser(5,12,17);
			unitInitialiser c4u15 = new unitInitialiser(4,13,17);

			initList.add(c4u1);
			initList.add(c4u2);
			initList.add(c4u3);
			initList.add(c4u4);
			initList.add(c4u5);
			initList.add(c4u6);
			initList.add(c4u7);
			initList.add(c4u8);
			initList.add(c4u9);
			initList.add(c4u10);
			initList.add(c4u11);
			initList.add(c4u12);
			initList.add(c4u13);
			initList.add(c4u14);
			initList.add(c4u15);			
			break;
			
		case 5:
			unitInitialiser c5u1 = new unitInitialiser(2,1,3);
			unitInitialiser c5u2 = new unitInitialiser(1,5,3);
			unitInitialiser c5u3 = new unitInitialiser(2,13,3);
			unitInitialiser c5u4 = new unitInitialiser(1,9,3);
			unitInitialiser c5u5 = new unitInitialiser(4,0,16);
			unitInitialiser c5u6 = new unitInitialiser(5,4,16);
			unitInitialiser c5u7 = new unitInitialiser(4,12,16);
			unitInitialiser c5u8 = new unitInitialiser(5,8,16);
			initList.add(c5u1);
			initList.add(c5u2);
			initList.add(c5u3);
			initList.add(c5u4);
			initList.add(c5u5);
			initList.add(c5u6);
			initList.add(c5u7);
			initList.add(c5u8);
			break;
			
		case 6:
			unitInitialiser c6u1 = new unitInitialiser(3,4,6);
			unitInitialiser c6u2 = new unitInitialiser(7,4,7);
			unitInitialiser c6u3 = new unitInitialiser(2,6,2);
			unitInitialiser c6u4 = new unitInitialiser(2,6,12);
			unitInitialiser c6u5 = new unitInitialiser(6,19,7);
			unitInitialiser c6u6 = new unitInitialiser(8,19,8);
			unitInitialiser c6u7 = new unitInitialiser(5,18,2);
			unitInitialiser c6u8 = new unitInitialiser(5,18,12);
			initList.add(c6u1);
			initList.add(c6u2);
			initList.add(c6u3);
			initList.add(c6u4);
			initList.add(c6u5);
			initList.add(c6u6);
			initList.add(c6u7);
			initList.add(c6u8);
			break;
			
		case 7:
			unitInitialiser c7u1 = new unitInitialiser(3,0,7);
			unitInitialiser c7u2 = new unitInitialiser(7,0,8);
			unitInitialiser c7u3 = new unitInitialiser(2,1,2);
			unitInitialiser c7u4 = new unitInitialiser(2,1,12);
			unitInitialiser c7u5 = new unitInitialiser(6,18,7);
			unitInitialiser c7u6 = new unitInitialiser(8,18,8);
			unitInitialiser c7u7 = new unitInitialiser(5,17,2);
			unitInitialiser c7u8 = new unitInitialiser(5,17,12);
			initList.add(c7u1);
			initList.add(c7u2);
			initList.add(c7u3);
			initList.add(c7u4);
			initList.add(c7u5);
			initList.add(c7u6);
			initList.add(c7u7);
			initList.add(c7u8);
			break;
			
		case 8:
			unitInitialiser c8u1 = new unitInitialiser(1,1,1);
			unitInitialiser c8u2 = new unitInitialiser(2,4,1);
			unitInitialiser c8u3 = new unitInitialiser(3,13,1);
			unitInitialiser c8u4 = new unitInitialiser(4,1,13);
			unitInitialiser c8u5 = new unitInitialiser(5,4,13);
			unitInitialiser c8u6 = new unitInitialiser(6,13,13);
			unitInitialiser c8u7 = new unitInitialiser(7,8,1);
			unitInitialiser c8u8 = new unitInitialiser(8,8,13);
			initList.add(c8u1);
			initList.add(c8u2);
			initList.add(c8u3);
			initList.add(c8u4);
			initList.add(c8u5);
			initList.add(c8u6);
			initList.add(c8u7);
			initList.add(c8u8);
			break;
			
			
		}
		
		
		return initList;
		
		
	}



	public static class unitInitialiser{
		int type;
		public int xpos;
		public int ypos;

		public unitInitialiser(int t, int x, int y){
			this.type = t;
			this.xpos = x;
			this.ypos = y;
		}
	}

	private static void fillArea(int x, int y, int width, int height, int type, GameMap map) {
		for (int xposition = x; xposition < x + width; xposition ++) {
			for (int yposition = y; yposition < y + height; yposition ++){
				map.tiletypes[xposition][yposition] = type;
			}
		}
	}

	/*private static void fillWalls(GameMap map) {
		for (int x = 0; x <= map.MAP_WIDTH; x++){
			for (int y = 0; y <= map.MAP_WIDTH; y++){
				if (map.tiletypes[x][y] == 3) {
					GameMap.wallLocations[x][y] = 3;
				}
			}
		}	
	}*/
}
