package game;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import javax.swing.JFileChooser;

public class MapSerializer {


	/**
	 * This class is used to save GameMaps to file
	 */
	

	public MapSerializer(){

	}
	
	/**
	 * Save a map
	 * @param save: the map we will save
	 * @param x: the slot to save it to
	 */


	public void SaveMap(GameMap save, int x){

		try {
			
			FileOutputStream fileOut = null;
			
			switch (x){

			case 0: 
				fileOut = new FileOutputStream("savedMap0.ser");
				break;
				
			case 1: 
				fileOut = new FileOutputStream("savedMap1.ser");
				break;

			case 2: 
				fileOut = new FileOutputStream("savedMap2.ser");
				break;
				
			case 3: 
				fileOut = new FileOutputStream("savedMap3.ser");
				break;
				
			case 4: 
				fileOut = new FileOutputStream("savedMap4.ser");
				break;
			}

			ObjectOutputStream out = new ObjectOutputStream(fileOut);
			out.writeObject(save);
			out.close();
			fileOut.close();
			System.out.println("Map successfullly saved to file");

		} catch (IOException i) {
			i.printStackTrace();
		}
	}
	
	/**
	 * This will load a map
	 * @param x: the slot to load from 
	 * @return: the map that we loaded
	 */

	public GameMap LoadMap(int x){

		GameMap load = null;

		try{
			
			FileInputStream fileIn = null; 
			
			switch (x){

			case 0: 
				fileIn = new FileInputStream("savedMap0.ser");
				break;
				
			case 1: 
				fileIn = new FileInputStream("savedMap1.ser");
				break;

			case 2: 
				fileIn = new FileInputStream("savedMap2.ser");
				break;
				
			case 3: 
				fileIn = new FileInputStream("savedMap3.ser");
				break;
				
			case 4: 
				fileIn = new FileInputStream("savedMap4.ser");
				break;
			}
			
			ObjectInputStream in = new ObjectInputStream(fileIn);
			load = (GameMap) in.readObject();
			in.close();
			fileIn.close();
			System.out.println("Map successfully loaded");
			return load;
		}

		catch(IOException i)
		{
			i.printStackTrace();
			return null;
		}

		catch(ClassNotFoundException c)
		{
			c.printStackTrace();
			return null; 
		}			
	}	
}
