package players;

import java.util.ArrayList;

import units.UnitInterface;
import game.Game;
import game.Turn;

public class HumanPlayer implements PlayerInterface{

	private boolean moved = false;
	private boolean fired = false;
	private boolean movedOnce = false;

	private int selectedx = -1;
	private int selectedy = -1;
	private int lastFindx = -1;
	private int lastFindY = -1;

	private static int moverange = 1;

	game.EndGameWindow gameOver;

	public int getMoverange() {
		return moverange;
	}
	public void setMoverange(int moverange) {
		HumanPlayer.moverange = moverange;
	}

	private int moveDistanceTracker;

	private int playerID = 0;	
	private boolean isAI = false;

	public HumanPlayer(int i) {
		playerID = i;
	}


	public int getPlayerID() {
		return playerID;
	}
	public void setPlayerID(int x){
		playerID = x;		
	}

	public boolean isAI(){
		return isAI;
	}

	//copied from mpgame

	public int getSelectedx() {
		return selectedx;
	}

	public void setSelectedx(int selectedx) {
		this.selectedx = selectedx;
	}

	public int getSelectedy() {
		return selectedy;
	}

	public void setSelectedy(int selectedy) {
		this.selectedy = selectedy;
	}

	public int getLastFindx() {
		return lastFindx;
	}

	public void setLastFindx(int lastFindx) {
		this.lastFindx = lastFindx;
	}

	public int getLastFindY() {
		return lastFindY;
	}

	public void setLastFindY(int lastFindY) {
		this.lastFindY = lastFindY;
	}

	public boolean isFired() {
		return fired;
	}

	public void setFired(boolean fired) {
		this.fired = fired;
	}

	public boolean isMoved() {
		return moved;
	}

	public void setMoved(boolean moved) {
		this.moved = moved;
	}

	public boolean isMovedOnce() {
		return movedOnce;
	}

	public void setMovedOnce(boolean movedOnce) {
		this.movedOnce = movedOnce;
	}

	public int getMoveDistanceTracker() {
		return moveDistanceTracker;
	}

	public void setMoveDistanceTracker(int moveDistanceTracker) {
		this.moveDistanceTracker = moveDistanceTracker;
	}

	public void chooseMove(Game game) {

		if (game.getMap().redUnitCount == 0 || game.getMap().blueUnitCount == 0) {
			gameOver.setVisible(true);
		}

		else {
			System.out.println("Choosing Human Move");
			game.getGlassPane().setVisible(false);	
		}
	}

	public void swapPlayer(Game game) {
		
		/**
		 * each units position needs to be updated so that the can properly clone the game state
		 */
		
		game.getMap().builtUnits = new ArrayList<UnitInterface>();
		
		for (int i = 0; i < game.getMap().getWidth(); i++){
			for (int j = 0; j < game.getMap().getHeight(); j++){
				if (game.getMap().getUnitInNode(i,j) != null && game.getMap().getUnitInNode(i,j).isAlive() == true){
					UnitInterface unit = game.getMap().getUnitInNode(i,j);
					//System.out.println("Unit found in " + i + ", " + j);
					unit.setCurrentPosX(i);
					unit.setCurrentPosY(j);
					game.getMap().builtUnits.add(unit);
					//System.out.println("Units currentpos is now " + game.getMap().getUnitInNode(i,j).getCurrentPosX() + ", " + game.getMap().getUnitInNode(i,j).getCurrentPosY());
				}
			}
		}
		

		for (UnitInterface u: game.getMap().builtUnits){
			System.out.println("Unit u has current position " + u.getCurrentPosX() + ", " + u.getCurrentPosY());
		}
		
		//call the other player's choose move method and disable mouse 
		game.getGlassPane().setVisible(true);
		setSelectedx(-1);
		setSelectedy(-1);
		setLastFindx(-1);
		setFired(false);
		setMoved(false);
		movedOnce = false;

		game.repaint(0);

		System.out.println("red units: " + game.getMap().redUnitCount);
		System.out.println("blue units: " + game.getMap().blueUnitCount);
		
		
		
		if (game.getTurnID() == 0) { game.setTurnID(1);}
		else if (game.getTurnID() == 1) { game.setTurnID(0);}
		
		game.turnCount += 1;
		System.out.println("Turns taken =" + game.turnCount);
		System.out.println("Turn Limit is =" + game.maxTurns);
		if (game.maxTurns != -1 && game.turnCount >= game.maxTurns){
			gameOver = new game.EndGameWindow(game.turnCount, game.getMap().redUnitCount, game.getMap().blueUnitCount, game.initialRed, game.initialBlue);
			gameOver.setVisible(true);
			game.dispose();
		}
		
		if (game.getMap().redUnitCount == 0 || game.getMap().blueUnitCount == 0) {
			gameOver = new game.EndGameWindow(game.turnCount, game.getMap().redUnitCount, game.getMap().blueUnitCount, game.initialRed, game.initialBlue);
			gameOver.setVisible(true);
			game.dispose();
		}


		else if (game.getCurrentPlayer() == game.getPlayer1()) {
			game.currentPlayer = game.getPlayer2();
			System.out.println("Is this null" + game.getPlayer2());
			game.getPlayer2().chooseMove(game);
		}
		else if (game.getCurrentPlayer() == game.getPlayer2()) {
			game.currentPlayer = game.getPlayer1();
			game.getPlayer1().chooseMove(game);
		}	

	}
	@Override
	public void swapPlayer(Game game, Turn bestMove) {
		// TODO Auto-generated method stub
	}





}
