package players;

/**
 * This interface must be implemented by AIs and Humans to ensure they can interact
 * with each other 
 */

import game.Game;
import game.Turn;

public interface PlayerInterface {

	public int getPlayerID();

	public void setPlayerID(int x);

	public boolean isAI();

	public int getSelectedx();

	public void setSelectedx(int selectedx);

	public int getSelectedy();

	public void setSelectedy(int selectedy);

	public int getLastFindx();

	public void setLastFindx(int lastFindx);

	public int getLastFindY();

	public void setLastFindY(int lastFindY);

	public boolean isFired();

	public void setFired(boolean fired);

	public boolean isMoved();

	public void setMoved(boolean moved);

	public boolean isMovedOnce();

	public void setMovedOnce(boolean movedOnce);

	public int getMoveDistanceTracker();

	public void setMoveDistanceTracker(int moveDistanceTracker);
	
	public int getMoverange();
	public void setMoverange(int moverange);

	public void chooseMove(Game game);
	
	public void swapPlayer(Game game);
	public void swapPlayer(Game game, Turn bestMove);
	
	


}
